(* $Id: gtkn.mli,v 1.1 2010-11-08 09:19:46 deraugla Exp $ *)

type t 'a = 'abstract;

type widget 'a = [ > `widget ] as 'a;
type drawable 'a = [ > `drawable ] as 'a;
type window_dr = [ = `drawable | `gdkwindow ];
type pixmap_dr = [ = `drawable | `gdkpixmap ];

value window : string -> t Gtk.window;

value window_move : t Gtk.window -> int -> int -> unit;
value window_add_accel_group : t Gtk.window -> Gtk.accel_group -> unit;

value widget_destroy : t [ > `gtk ] -> unit;
value widget_hide : t (widget _) -> unit;
value widget_realize : t (widget _) -> unit;
value widget_show : t (widget _) -> unit;

value container_add : t [ > `container ] -> t (widget _) -> unit;
value pack_start : t Gtk.box -> t (widget _) -> unit;
value pack_end : t Gtk.box -> t (widget _) -> unit;

value alignment :
  (float * float) -> (float * float) -> int -> int -> t Gtk.alignment;

value box : Gtk.Tags.orientation -> t Gtk.box;

value drawing_area : int -> int -> t Gtk.drawing_area;

value frame : string -> t Gtk.frame;

value label : string -> int -> int -> t Gtk.label;
value label_set_text : t Gtk.label -> string -> unit;

value menu : unit -> t Gtk.menu;
value menu_bar : unit -> t Gtk.menu_bar;
value menu_item : string -> t Gtk.menu_item;
value menu_check_item : string -> bool -> t Gtk.check_menu_item;
value menu_radio_item :
  option (Gtk.group Gtk.radio_menu_item) -> string -> bool ->
    t Gtk.radio_menu_item;
value menu_separator_item : unit -> t Gtk.menu_item;

value menu_append : t [ > `menushell ] -> t (widget _) -> unit;
value menu_set_submenu : t [ > `menuitem ] -> t [ > `menu ] -> unit;

value notebook : unit -> t Gtk.notebook;
value notebook_append_page :
  t Gtk.notebook -> t Gtk.label -> t (widget _) -> int;
value notebook_remove_page : t Gtk.notebook -> int -> unit;

value progress_bar : unit -> t Gtk.progress_bar;

value group : t Gtk.radio_menu_item -> Gtk.group Gtk.radio_menu_item;

value sgn_destroy : GtkSignal.t [ > `gtk ] (unit -> unit);
value sgn_activate : GtkSignal.t [ > `menuitem ] (unit -> unit);
value signal_connect : t 'a -> GtkSignal.t 'a 'b -> 'b -> unit;

value widget_add_accelerator :
  t [ > `menuitem | `widget ] -> Gtk.accel_group -> list Gdk.Tags.modifier ->
    Gdk.keysym -> unit;
value widget_remove_accelerator :
  t [ > `menuitem | `widget ] -> Gtk.accel_group -> list Gdk.Tags.modifier ->
    Gdk.keysym -> unit;

value create_gc : t (drawable _) -> Gdk.gc;
value drawable : t (widget _) -> Gdk.window;

value set : t 'a -> Gobject.property 'a 'b -> 'b -> unit;
value get : t 'a -> Gobject.property 'a 'b -> 'b;

value set_back_pixmap : t window_dr -> t  pixmap_dr -> unit;

value widget_window : t (widget _) -> t window_dr;

value pixmap : int -> int -> t pixmap_dr;

value draw_rectangle :
  t (drawable _) -> Gdk.gc -> int -> int -> int -> int -> unit;
value fill_rectangle :
  t (drawable _) -> Gdk.gc -> int -> int -> int -> int -> unit;
value draw_arc :
  t (drawable _) -> Gdk.gc -> int -> int -> int -> int -> float -> float ->
    unit;
value draw_pixmap :
  t (drawable _) -> Gdk.gc -> t pixmap_dr ->
     int -> int -> int -> int -> int -> int -> unit;
value draw_point :
  t (drawable _) -> Gdk.gc -> int -> int -> unit;

value window_clear : t window_dr -> unit;

value set_cursor : t window_dr -> Gdk.cursor -> unit;

value add_events : t (widget _) -> list Gdk.Tags.event_mask -> unit;
